package scripts.migration.from4_4To4_5.general;

import java.util.Collection;

import info.magnolia.cms.core.Content;
import info.magnolia.cms.core.HierarchyManager;
import info.magnolia.cms.core.ItemType;
import info.magnolia.cms.util.ContentUtil;
import info.magnolia.context.Context;
import info.magnolia.context.MgnlContext;

import org.apache.commons.lang.StringUtils;

import scripts.migration.from4_4To4_5.util.MigrationUtil;

class TemplatesAndParagraphsToPagesAndComponents {

  Context ctx
  HierarchyManager hm

  def moveTemplatesAndParagraphs(String modulePath){
    if(hm == null){
      hm = MgnlContext.getHierarchyManager("config")
    }
    if(hm.isExist(modulePath)){
      Content moduleNode = hm.getContent(modulePath)
      Content templatesNode = MigrationUtil.getOrCreateContent(moduleNode, "templates", ItemType.CONTENT)
      //Checking if already been processed
      if(!templatesNode.hasContent("pages") && !templatesNode.hasContent("components")){
        //Page templates exist
        if(templatesNode.hasChildren() || templatesNode.hasChildren(ItemType.CONTENTNODE.getSystemName())){
          Content pagesNode = MigrationUtil.renameNode(templatesNode, "pages")
          templatesNode = MigrationUtil.getOrCreateContent(moduleNode, "templates", ItemType.CONTENT)
          ContentUtil.moveInSession(pagesNode, templatesNode.getHandle()+"/"+pagesNode.getName())
        }
        if(moduleNode.hasContent("paragraphs")){
          //Moving the paragrpahs node into the templates node and rename to components
          ContentUtil.moveInSession(moduleNode.getContent("paragraphs"), templatesNode.getHandle()+"/components")
        }
      }
    }
    hm.save()
  }

  /**
   * Call this def to move the templates and paragraphs of your module to the new structure
   */
  def doSTK(String moduleName){
    doModule("standard-templating-kit")
  }

  /**
   * Call this def to move the templates and paragraphs of your module to the new structure
   */
  def doModule(String moduleName){
    hm = ctx.getHierarchyManager("config")
    String modulePath = "/modules/"+moduleName
    if(hm.isExist(modulePath)){
      moveTemplatesAndParagraphs(modulePath)
    }
  }

  /**
   * Call this def to move the templates and paragraphs of your modules
   */
  def doModules(Collection moduleNames){
    moduleNames.each{ String moduleName -> doModule(moduleName) }
  }

}
