package scripts.migration.from4_4To4_5.general;

import java.util.Collection;
import java.util.Map;

import javax.swing.plaf.MenuItemUI;

import info.magnolia.cms.core.Content;
import info.magnolia.cms.core.HierarchyManager;
import info.magnolia.cms.core.ItemType;
import info.magnolia.cms.util.ContentUtil
import info.magnolia.cms.util.PathUtil;
import info.magnolia.context.Context;
import info.magnolia.context.MgnlContext;

import org.apache.commons.lang.StringUtils;

import scripts.migration.from4_4To4_5.util.MigrationUtil;

import info.magnolia.rendering.template.AreaDefinition;

class TransformSimpleTemplates {

  Context ctx
  HierarchyManager hm

  Map dialogsIdMap = [:]

  //for log
  String moduleName
  Collection dialogNotChanged = []

  def doModules(Collection moduleNames){
      moduleNames.each{ String moduleName ->
          doModule(moduleName)
      }
  }

  def doModule(String moduleName){
      this.moduleName = moduleName
      migrateTemplateProperties(moduleName)
  }

  def log(){
      println " *** "
      println " *** Start log summary of template transformation in module: "+moduleName
      println " *** "
      println " ** Dialogs ID's Not Changed: "
      println      dialogNotChanged
      println " *** "
      println " *** End log summary of template transformation in module: "+moduleName
      println " *** "
  }

  /**
   * Update only the properties of the templates found within your module.
   * Call this method if your module provides simple definitions and does not need a huge transformation.
   *
   */
  def private migrateTemplateProperties(String moduleName){
      resetLog()
      hm = ctx.getHierarchyManager('config');
      def templates = hm.getContent('/modules/'+moduleName+'/templates');

      //This can only be executes on the toplevel of a template def
      ContentUtil.collectAllChildren(templates).each { Content templateDef ->
          MigrationUtil.updateTemplatePropertiesGeneric(templateDef, dialogsIdMap, dialogNotChanged)
          propChangesForEveryTemplateOrSubNode(templateDef)
      }
      ContentUtil.visit(templates, visitor)
      hm.save();
  }

  def visitor = { Content templateOrSubnode ->
      propChangesForEveryTemplateOrSubNode(templateOrSubnode)
  } as ContentUtil.Visitor

  def static propChangesForEveryTemplateOrSubNode(Content templateOrSubnode){
      MigrationUtil.updateClassAndModelClass(templateOrSubnode, MigrationUtil.mapOfDeprecatedClassesToReplace())
      MigrationUtil.updateClassAndModelClass(templateOrSubnode, MigrationUtil.mapOfMovedClasses())
      MigrationUtil.updateChangedTemplateScripts(templateOrSubnode, MigrationUtil.mapOfChangedFreemarkerScripts())
      MigrationUtil.updateBasePathInTemplateScriptProperty(templateOrSubnode)
  }

  def private resetLog(){
      dialogNotChanged = []
  }

}
